#include <span>
#include <print>
#include <filesystem>
#include <windows.h>
#include <psapi.h>
#include <safetyhook.hpp>

using SECTION_INHERIT = int;

auto hook_NtMapViewOfSection = safetyhook::InlineHook {};

auto NTAPI hook_fn_NtMapViewOfSection(
    _In_         HANDLE           SectionHandle,
    _In_         HANDLE           ProcessHandle,
    _Inout_      PVOID            *BaseAddress,
    _In_         ULONG_PTR        ZeroBits,
    _In_         SIZE_T           CommitSize,
    _Inout_opt_  PLARGE_INTEGER   SectionOffset,
    _Inout_      PSIZE_T          ViewSize,
    _In_         SECTION_INHERIT  InheritDisposition,
    _In_         ULONG            AllocationType,
    _In_         ULONG            Win32Protect
) -> NTSTATUS
{
    auto const result = hook_NtMapViewOfSection.stdcall<NTSTATUS>(
        SectionHandle, ProcessHandle, BaseAddress, ZeroBits,
        CommitSize, SectionOffset, ViewSize, InheritDisposition,
        AllocationType, Win32Protect);

    auto path = std::string(MAX_PATH, '\0');
    auto size = GetMappedFileNameA(ProcessHandle, *BaseAddress, path.data(), MAX_PATH);

    if (!size) [[unlikely]]
        return result;

    path.resize(size);

    if (path.ends_with("library_a.dll"))
    {
        auto region = std::span { static_cast<std::uint8_t*>(*BaseAddress), *ViewSize };
        auto target = std::ranges::search(region, "1337").begin();

        if (target == region.end())
            return result;

        auto old = DWORD {};
        auto ptr = region.data() + std::distance(region.begin(), target);

        VirtualProtect(ptr, 4, PAGE_EXECUTE_READWRITE, &old);
        std::copy_n(/* IT'S OVER 9000! */ "9001", 4, ptr);
        VirtualProtect(ptr, 4, old, &old);
    }

    return result;
}

auto main() -> int
{
    auto const NtMapViewOfSection =
        GetProcAddress(GetModuleHandleA("ntdll.dll"), "NtMapViewOfSection");

    hook_NtMapViewOfSection = safetyhook::create_inline
        (NtMapViewOfSection, hook_fn_NtMapViewOfSection);

    if (LoadLibraryA("library_b.dll"))
        std::println("library_b.dll loaded");
}